//
// Simple passthrough vertex shader
//
attribute vec3 in_Position;                  // (x,y,z)
//attribute vec3 in_Normal;                  // (x,y,z)     unused in this shader.
attribute vec4 in_Colour;                    // (r,g,b,a)
attribute vec2 in_TextureCoord;              // (u,v)

varying vec2 v_vTexcoord;
varying vec4 v_vColour;
varying vec2 fragCoord;
uniform vec2 iResolution;
uniform float iGlobalTime;

void main()
{
    vec4 object_space_pos = vec4( in_Position.x * 2.0 - 32.0, in_Position.y * 2.0 - 48.0, in_Position.z, 1.0);
    gl_Position = gm_Matrices[MATRIX_WORLD_VIEW_PROJECTION] * object_space_pos;
    
    v_vColour = in_Colour;
    v_vTexcoord = in_TextureCoord;
    fragCoord = in_Position.xy;

}

//######################_==_YOYO_SHADER_MARKER_==_######################@~//
// Simple passthrough fragment shader
//
varying vec2 v_vTexcoord;
varying vec4 v_vColour;
varying vec2 fragCoord;
uniform vec2 iResolution;
uniform float iGlobalTime;


/*float rand( vec2 p)
{
    return fract( cos( dot( p, vec2(5.237,6.378)))*8463.648);
}


float noise( vec2 p)
{
    float x1 = rand(vec2(floor(p.x),floor(p.y)));
    float x2 = rand(vec2(ceil(p.x),floor(p.y)));
    float top = mix(x1,x2,smoothstep(0.0,1.0,fract(p.x)));
    
    x1 = rand(vec2(floor(p.x),ceil(p.y)));
    x2 = rand(vec2(ceil(p.x),ceil(p.y)));
    float bottom = mix(x1,x2,smoothstep(0.0,1.0,fract(p.x)));
    
    return mix(top,bottom,smoothstep(0.0,1.0,fract(p.y)));
}
*/

void main()
{
   // gl_FragColor = texture2D( gm_BaseTexture, v_vTexcoord );
   

    vec2 uv = fragCoord.xy / iResolution.xy;

        
    uv.y += (cos((uv.y + (iGlobalTime * 0.04)) * 45.0) * 0.003) + (cos((uv.y + (iGlobalTime * 0.1)) * 10.0) * 0.002);    
    uv.x += (sin((uv.y + (iGlobalTime * 0.07)) * 15.0) * 0.0045) + (sin((uv.y + (iGlobalTime * 0.1)) * 15.0) * 0.002);
    
    
    gl_FragColor = texture2D(gm_BaseTexture,uv);
}

